org.springframework.orm.hibernate3

## Class HibernateTransactionManager

- java.lang.Object
- - org.springframework.transaction.support.AbstractPlatformTransactionManager
  - - org.springframework.orm.hibernate3.HibernateTransactionManager

- All Implemented Interfaces:
    Serializable, Aware, BeanFactoryAware, InitializingBean, PlatformTransactionManager, ResourceTransactionManager

      public class HibernateTransactionManager
      extends AbstractPlatformTransactionManager
      implements ResourceTransactionManager, BeanFactoryAware, InitializingBean

  `PlatformTransactionManager` implementation for a single Hibernate `SessionFactory`. Binds a Hibernate Session from the specified factory to the thread, potentially allowing for one thread-bound Session per factory. `SessionFactoryUtils` and `HibernateTemplate` are aware of thread-bound Sessions and participate in such transactions automatically. Using either of those or going through `SessionFactory.getCurrentSession()` is required for Hibernate access code that needs to support this transaction handling mechanism.

  Supports custom isolation levels, and timeouts that get applied as Hibernate transaction timeouts.

  This transaction manager is appropriate for applications that use a single Hibernate SessionFactory for transactional data access, but it also supports direct DataSource access within a transaction (i.e. plain JDBC code working with the same DataSource). This allows for mixing services which access Hibernate and services which use plain JDBC (without being aware of Hibernate)! Application code needs to stick to the same simple Connection lookup pattern as with `DataSourceTransactionManager` (i.e. `DataSourceUtils.getConnection(javax.sql.DataSource)` or going through a `TransactionAwareDataSourceProxy`).

  Note: To be able to register a DataSource's Connection for plain JDBC code, this instance needs to be aware of the DataSource (`setDataSource(javax.sql.DataSource)`). The given DataSource should obviously match the one used by the given SessionFactory. To achieve this, configure both to the same JNDI DataSource, or preferably create the SessionFactory with `LocalSessionFactoryBean` and a local DataSource (which will be autodetected by this transaction manager).

  JTA (usually through `JtaTransactionManager`) is necessary for accessing multiple transactional resources within the same transaction. The DataSource that Hibernate uses needs to be JTA-enabled in such a scenario (see container setup). Normally, JTA setup for Hibernate is somewhat container-specific due to the JTA TransactionManager lookup, required for proper transactional handling of the SessionFactory-level read-write cache.

  Fortunately, there is an easier way with Spring: `SessionFactoryUtils` (and thus `HibernateTemplate`) registers synchronizations with Spring's `TransactionSynchronizationManager` (as used by `JtaTransactionManager`), for proper after-completion callbacks. Therefore, as long as Spring's JtaTransactionManager drives the JTA transactions, Hibernate does not require any special configuration for proper JTA participation. Note that there are special restrictions with EJB CMT and restrictive JTA subsystems: See `JtaTransactionManager`'s javadoc for details.

  On JDBC 3.0, this transaction manager supports nested transactions via JDBC 3.0 Savepoints. The `AbstractPlatformTransactionManager.setNestedTransactionAllowed(boolean)` "nestedTransactionAllowed"} flag defaults to "false", though, as nested transactions will just apply to the JDBC Connection, not to the Hibernate Session and its cached objects. You can manually set the flag to "true" if you want to use nested transactions for JDBC access code which participates in Hibernate transactions (provided that your JDBC driver supports Savepoints). Note that Hibernate itself does not support nested transactions! Hence, do not expect Hibernate access code to semantically participate in a nested transaction.

  Requires Hibernate 3.2 or later, as of Spring 3.0.

  Since:
    1.2
  Author:
    Juergen Hoeller
  See Also:
    `setSessionFactory(org.hibernate.SessionFactory)`, `setDataSource(javax.sql.DataSource)`, `LocalSessionFactoryBean`, `SessionFactoryUtils.getSession(org.hibernate.SessionFactory, boolean)`, `SessionFactoryUtils.applyTransactionTimeout(org.hibernate.Query, org.hibernate.SessionFactory)`, `SessionFactoryUtils.releaseSession(org.hibernate.Session, org.hibernate.SessionFactory)`, `HibernateTemplate`, `SessionFactory.getCurrentSession()`, `DataSourceUtils.getConnection(javax.sql.DataSource)`, `DataSourceUtils.applyTransactionTimeout(java.sql.Statement, javax.sql.DataSource)`, `DataSourceUtils.releaseConnection(java.sql.Connection, javax.sql.DataSource)`, `JdbcTemplate`, `DataSourceTransactionManager`, `JtaTransactionManager`, Serialized Form

- - ### Field Summary

    - ### Fields inherited from class org.springframework.transaction.support.AbstractPlatformTransactionManager

      `logger, SYNCHRONIZATION_ALWAYS, SYNCHRONIZATION_NEVER, SYNCHRONIZATION_ON_ACTUAL_TRANSACTION`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `HibernateTransactionManager()` Create a new HibernateTransactionManager instance.
    `HibernateTransactionManager(SessionFactory sessionFactory)` Create a new HibernateTransactionManager instance.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
    `protected DataAccessException` | `convertHibernateAccessException(HibernateException ex)` Convert the given HibernateException to an appropriate exception from the `org.springframework.dao` hierarchy.
    `protected DataAccessException` | `convertJdbcAccessException(JDBCException ex, SQLExceptionTranslator translator)` Convert the given Hibernate JDBCException to an appropriate exception from the `org.springframework.dao` hierarchy, using the given SQLExceptionTranslator.
    `protected void` | `doBegin(Object transaction, TransactionDefinition definition)` Begin a new transaction with semantics according to the given transaction definition.
    `protected void` | `doCleanupAfterCompletion(Object transaction)` Cleanup resources after transaction completion.
    `protected void` | `doCommit(DefaultTransactionStatus status)` Perform an actual commit of the given transaction.
    `protected Object` | `doGetTransaction()` Return a transaction object for the current transaction state.
    `protected void` | `doResume(Object transaction, Object suspendedResources)` Resume the resources of the current transaction.
    `protected void` | `doRollback(DefaultTransactionStatus status)` Perform an actual rollback of the given transaction.
    `protected void` | `doSetRollbackOnly(DefaultTransactionStatus status)` Set the given transaction rollback-only.
    `protected Object` | `doSuspend(Object transaction)` Suspend the resources of the current transaction.
    `DataSource` | `getDataSource()` Return the JDBC DataSource that this instance manages transactions for.
    `protected SQLExceptionTranslator` | `getDefaultJdbcExceptionTranslator()` Obtain a default SQLExceptionTranslator, lazily creating it if necessary.
    `Interceptor` | `getEntityInterceptor()` Return the current Hibernate entity interceptor, or `null` if none.
    `SQLExceptionTranslator` | `getJdbcExceptionTranslator()` Return the JDBC exception translator for this transaction manager, if any.
    `Object` | `getResourceFactory()` Return the resource factory that this transaction manager operates on, e.g.
    `SessionFactory` | `getSessionFactory()` Return the SessionFactory that this instance should manage transactions for.
    `protected boolean` | `isExistingTransaction(Object transaction)` Check if the given transaction object indicates an existing transaction (that is, a transaction which has already started).
    `protected boolean` | `isSameConnectionForEntireSession(Session session)` Return whether the given Hibernate Session will always hold the same JDBC Connection.
    `protected void` | `prepareForCommit(DefaultTransactionStatus status)` Make preparations for commit, to be performed before the `beforeCommit` synchronization callbacks occur.
    `void` | `setAutodetectDataSource(boolean autodetectDataSource)` Set whether to autodetect a JDBC DataSource used by the Hibernate SessionFactory, if set via LocalSessionFactoryBean's `setDataSource`.
    `void` | `setBeanFactory(BeanFactory beanFactory)` The bean factory just needs to be known for resolving entity interceptor bean names.
    `void` | `setDataSource(DataSource dataSource)` Set the JDBC DataSource that this instance should manage transactions for.
    `void` | `setEarlyFlushBeforeCommit(boolean earlyFlushBeforeCommit)` Set whether to perform an early flush before proceeding with a commit.
    `void` | `setEntityInterceptor(Interceptor entityInterceptor)` Set a Hibernate entity interceptor that allows to inspect and change property values before writing to and reading from the database.
    `void` | `setEntityInterceptorBeanName(String entityInterceptorBeanName)` Set the bean name of a Hibernate entity interceptor that allows to inspect and change property values before writing to and reading from the database.
    `void` | `setHibernateManagedSession(boolean hibernateManagedSession)` Set whether to operate on a Hibernate-managed Session instead of a Spring-managed Session, that is, whether to obtain the Session through Hibernate's `SessionFactory.getCurrentSession()` instead of `SessionFactory.openSession()` (with a Spring `TransactionSynchronizationManager` check preceding it).
    `void` | `setJdbcExceptionTranslator(SQLExceptionTranslator jdbcExceptionTranslator)` Set the JDBC exception translator for this transaction manager.
    `void` | `setPrepareConnection(boolean prepareConnection)` Set whether to prepare the underlying JDBC Connection of a transactional Hibernate Session, that is, whether to apply a transaction-specific isolation level and/or the transaction's read-only flag to the underlying JDBC Connection.
    `void` | `setSessionFactory(SessionFactory sessionFactory)` Set the SessionFactory that this instance should manage transactions for.

    - ### Methods inherited from class org.springframework.transaction.support.AbstractPlatformTransactionManager

      `commit, determineTimeout, getDefaultTimeout, getTransaction, getTransactionSynchronization, invokeAfterCompletion, isFailEarlyOnGlobalRollbackOnly, isGlobalRollbackOnParticipationFailure, isNestedTransactionAllowed, isRollbackOnCommitFailure, isValidateExistingTransaction, newTransactionStatus, prepareSynchronization, prepareTransactionStatus, registerAfterCompletionWithExistingTransaction, resume, rollback, setDefaultTimeout, setFailEarlyOnGlobalRollbackOnly, setGlobalRollbackOnParticipationFailure, setNestedTransactionAllowed, setRollbackOnCommitFailure, setTransactionSynchronization, setTransactionSynchronizationName, setValidateExistingTransaction, shouldCommitOnGlobalRollbackOnly, suspend, triggerBeforeCommit, triggerBeforeCompletion, useSavepointForNestedTransaction`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.springframework.transaction.PlatformTransactionManager

      `commit, getTransaction, rollback`

- - ### Constructor Detail

    - #### HibernateTransactionManager

          public HibernateTransactionManager()

      Create a new HibernateTransactionManager instance. A SessionFactory has to be set to be able to use it.
      See Also:
        `setSessionFactory(org.hibernate.SessionFactory)`

    - #### HibernateTransactionManager

          public HibernateTransactionManager(SessionFactory sessionFactory)

      Create a new HibernateTransactionManager instance.
      Parameters:
        `sessionFactory` - SessionFactory to manage transactions for

  - ### Method Detail

    - #### setSessionFactory

          public void setSessionFactory(SessionFactory sessionFactory)

      Set the SessionFactory that this instance should manage transactions for.

    - #### getSessionFactory

          public SessionFactory getSessionFactory()

      Return the SessionFactory that this instance should manage transactions for.

    - #### setDataSource

          public void setDataSource(DataSource dataSource)

      Set the JDBC DataSource that this instance should manage transactions for. The DataSource should match the one used by the Hibernate SessionFactory: for example, you could specify the same JNDI DataSource for both.

      If the SessionFactory was configured with LocalDataSourceConnectionProvider, i.e. by Spring's LocalSessionFactoryBean with a specified "dataSource", the DataSource will be auto-detected: You can still explictly specify the DataSource, but you don't need to in this case.

      A transactional JDBC Connection for this DataSource will be provided to application code accessing this DataSource directly via DataSourceUtils or JdbcTemplate. The Connection will be taken from the Hibernate Session.

      The DataSource specified here should be the target DataSource to manage transactions for, not a TransactionAwareDataSourceProxy. Only data access code may work with TransactionAwareDataSourceProxy, while the transaction manager needs to work on the underlying target DataSource. If there's nevertheless a TransactionAwareDataSourceProxy passed in, it will be unwrapped to extract its target DataSource.

      See Also:
        `setAutodetectDataSource(boolean)`, `LocalDataSourceConnectionProvider`, `AbstractSessionFactoryBean.setDataSource(javax.sql.DataSource)`, `TransactionAwareDataSourceProxy`, `DataSourceUtils`, `JdbcTemplate`

    - #### getDataSource

          public DataSource getDataSource()

      Return the JDBC DataSource that this instance manages transactions for.

    - #### setAutodetectDataSource

          public void setAutodetectDataSource(boolean autodetectDataSource)

      Set whether to autodetect a JDBC DataSource used by the Hibernate SessionFactory, if set via LocalSessionFactoryBean's `setDataSource`. Default is "true".

      Can be turned off to deliberately ignore an available DataSource, in order to not expose Hibernate transactions as JDBC transactions for that DataSource.

      See Also:
        `setDataSource(javax.sql.DataSource)`, `AbstractSessionFactoryBean.setDataSource(javax.sql.DataSource)`

    - #### setPrepareConnection

          public void setPrepareConnection(boolean prepareConnection)

      Set whether to prepare the underlying JDBC Connection of a transactional Hibernate Session, that is, whether to apply a transaction-specific isolation level and/or the transaction's read-only flag to the underlying JDBC Connection.

      Default is "true". If you turn this flag off, the transaction manager will not support per-transaction isolation levels anymore. It will not call `Connection.setReadOnly(true)` for read-only transactions anymore either. If this flag is turned off, no cleanup of a JDBC Connection is required after a transaction, since no Connection settings will get modified.

      See Also:
        `Connection.setTransactionIsolation(int)`, `Connection.setReadOnly(boolean)`

    - #### setHibernateManagedSession

          public void setHibernateManagedSession(boolean hibernateManagedSession)

      Set whether to operate on a Hibernate-managed Session instead of a Spring-managed Session, that is, whether to obtain the Session through Hibernate's `SessionFactory.getCurrentSession()` instead of `SessionFactory.openSession()` (with a Spring `TransactionSynchronizationManager` check preceding it).

      Default is "false", i.e. using a Spring-managed Session: taking the current thread-bound Session if available (e.g. in an Open-Session-in-View scenario), creating a new Session for the current transaction otherwise.

      Switch this flag to "true" in order to enforce use of a Hibernate-managed Session. Note that this requires `SessionFactory.getCurrentSession()` to always return a proper Session when called for a Spring-managed transaction; transaction begin will fail if the `getCurrentSession()` call fails.

      This mode will typically be used in combination with a custom Hibernate `CurrentSessionContext` implementation that stores Sessions in a place other than Spring's TransactionSynchronizationManager. It may also be used in combination with Spring's Open-Session-in-View support (using Spring's default `SpringSessionContext`), in which case it subtly differs from the Spring-managed Session mode: The pre-bound Session will not receive a `clear()` call (on rollback) or a `disconnect()` call (on transaction completion) in such a scenario; this is rather left up to a custom CurrentSessionContext implementation (if desired).

    - #### setEarlyFlushBeforeCommit

          public void setEarlyFlushBeforeCommit(boolean earlyFlushBeforeCommit)

      Set whether to perform an early flush before proceeding with a commit.

      Default is "false", performing an implicit flush as part of the actual commit step. Switch this to "true" in order to enforce an explicit early flush right before the actual commit step.

      An early flush happens before the before-commit synchronization phase, making flushed state visible to `beforeCommit` callbacks of registered `TransactionSynchronization` objects. Such explicit flush behavior is consistent with Spring-driven flushing in a JTA transaction environment, so may also get enforced for consistency with JTA transaction behavior.

      See Also:
        `prepareForCommit(org.springframework.transaction.support.DefaultTransactionStatus)`

    - #### setEntityInterceptorBeanName

          public void setEntityInterceptorBeanName(String entityInterceptorBeanName)

      Set the bean name of a Hibernate entity interceptor that allows to inspect and change property values before writing to and reading from the database. Will get applied to any new Session created by this transaction manager.

      Requires the bean factory to be known, to be able to resolve the bean name to an interceptor instance on session creation. Typically used for prototype interceptors, i.e. a new interceptor instance per session.

      Can also be used for shared interceptor instances, but it is recommended to set the interceptor reference directly in such a scenario.

      Parameters:
        `entityInterceptorBeanName` - the name of the entity interceptor in the bean factory
      See Also:
        `setBeanFactory(org.springframework.beans.factory.BeanFactory)`, `setEntityInterceptor(org.hibernate.Interceptor)`

    - #### setEntityInterceptor

          public void setEntityInterceptor(Interceptor entityInterceptor)

      Set a Hibernate entity interceptor that allows to inspect and change property values before writing to and reading from the database. Will get applied to any new Session created by this transaction manager.

      Such an interceptor can either be set at the SessionFactory level, i.e. on LocalSessionFactoryBean, or at the Session level, i.e. on HibernateTemplate, HibernateInterceptor, and HibernateTransactionManager. It's preferable to set it on LocalSessionFactoryBean or HibernateTransactionManager to avoid repeated configuration and guarantee consistent behavior in transactions.

      See Also:
        `LocalSessionFactoryBean.setEntityInterceptor(org.hibernate.Interceptor)`, `HibernateAccessor.setEntityInterceptor(org.hibernate.Interceptor)`, `HibernateAccessor.setEntityInterceptor(org.hibernate.Interceptor)`

    - #### getEntityInterceptor

          public Interceptor getEntityInterceptor()
                                           throws IllegalStateException,
                                                  BeansException

      Return the current Hibernate entity interceptor, or `null` if none. Resolves an entity interceptor bean name via the bean factory, if necessary.
      Throws:
        `IllegalStateException` - if bean name specified but no bean factory set
        `BeansException` - if bean name resolution via the bean factory failed
      See Also:
        `setEntityInterceptor(org.hibernate.Interceptor)`, `setEntityInterceptorBeanName(java.lang.String)`, `setBeanFactory(org.springframework.beans.factory.BeanFactory)`

    - #### setJdbcExceptionTranslator

          public void setJdbcExceptionTranslator(SQLExceptionTranslator jdbcExceptionTranslator)

      Set the JDBC exception translator for this transaction manager.

      Applied to any SQLException root cause of a Hibernate JDBCException that is thrown on flush, overriding Hibernate's default SQLException translation (which is based on Hibernate's Dialect for a specific target database).

      Parameters:
        `jdbcExceptionTranslator` - the exception translator
      See Also:
        `SQLException`, `JDBCException`, `SQLErrorCodeSQLExceptionTranslator`, `SQLStateSQLExceptionTranslator`

    - #### getJdbcExceptionTranslator

          public SQLExceptionTranslator getJdbcExceptionTranslator()

      Return the JDBC exception translator for this transaction manager, if any.

    - #### setBeanFactory

          public void setBeanFactory(BeanFactory beanFactory)

      The bean factory just needs to be known for resolving entity interceptor bean names. It does not need to be set for any other mode of operation.
      Specified by:
        `setBeanFactory` in interface `BeanFactoryAware`
      Parameters:
        `beanFactory` - owning BeanFactory (never `null`). The bean can immediately call methods on the factory.
      See Also:
        `setEntityInterceptorBeanName(java.lang.String)`

    - #### afterPropertiesSet

          public void afterPropertiesSet()

      Description copied from interface: `InitializingBean`
      Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

      This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

      Specified by:
        `afterPropertiesSet` in interface `InitializingBean`

    - #### getResourceFactory

          public Object getResourceFactory()

      Description copied from interface: `ResourceTransactionManager`
      Return the resource factory that this transaction manager operates on, e.g. a JDBC DataSource or a JMS ConnectionFactory.

      This target resource factory is usually used as resource key for `TransactionSynchronizationManager`'s resource bindings per thread.

      Specified by:
        `getResourceFactory` in interface `ResourceTransactionManager`
      Returns:
        the target resource factory (never `null`)
      See Also:
        `TransactionSynchronizationManager.bindResource(java.lang.Object, java.lang.Object)`, `TransactionSynchronizationManager.getResource(java.lang.Object)`

    - #### doGetTransaction

          protected Object doGetTransaction()

      Description copied from class: `AbstractPlatformTransactionManager`
      Return a transaction object for the current transaction state.

      The returned object will usually be specific to the concrete transaction manager implementation, carrying corresponding transaction state in a modifiable fashion. This object will be passed into the other template methods (e.g. doBegin and doCommit), either directly or as part of a DefaultTransactionStatus instance.

      The returned object should contain information about any existing transaction, that is, a transaction that has already started before the current `getTransaction` call on the transaction manager. Consequently, a `doGetTransaction` implementation will usually look for an existing transaction and store corresponding state in the returned transaction object.

      Specified by:
        `doGetTransaction` in class `AbstractPlatformTransactionManager`
      Returns:
        the current transaction object
      See Also:
        `AbstractPlatformTransactionManager.doBegin(java.lang.Object, org.springframework.transaction.TransactionDefinition)`, `AbstractPlatformTransactionManager.doCommit(org.springframework.transaction.support.DefaultTransactionStatus)`, `AbstractPlatformTransactionManager.doRollback(org.springframework.transaction.support.DefaultTransactionStatus)`, `DefaultTransactionStatus.getTransaction()`

    - #### isExistingTransaction

          protected boolean isExistingTransaction(Object transaction)

      Description copied from class: `AbstractPlatformTransactionManager`
      Check if the given transaction object indicates an existing transaction (that is, a transaction which has already started).

      The result will be evaluated according to the specified propagation behavior for the new transaction. An existing transaction might get suspended (in case of PROPAGATION_REQUIRES_NEW), or the new transaction might participate in the existing one (in case of PROPAGATION_REQUIRED).

      The default implementation returns `false`, assuming that participating in existing transactions is generally not supported. Subclasses are of course encouraged to provide such support.

      Overrides:
        `isExistingTransaction` in class `AbstractPlatformTransactionManager`
      Parameters:
        `transaction` - transaction object returned by doGetTransaction
      Returns:
        if there is an existing transaction
      See Also:
        `AbstractPlatformTransactionManager.doGetTransaction()`

    - #### doBegin

          protected void doBegin(Object transaction,
                     TransactionDefinition definition)

      Description copied from class: `AbstractPlatformTransactionManager`
      Begin a new transaction with semantics according to the given transaction definition. Does not have to care about applying the propagation behavior, as this has already been handled by this abstract manager.

      This method gets called when the transaction manager has decided to actually start a new transaction. Either there wasn't any transaction before, or the previous transaction has been suspended.

      A special scenario is a nested transaction without savepoint: If `useSavepointForNestedTransaction()` returns "false", this method will be called to start a nested transaction when necessary. In such a context, there will be an active transaction: The implementation of this method has to detect this and start an appropriate nested transaction.

      Specified by:
        `doBegin` in class `AbstractPlatformTransactionManager`
      Parameters:
        `transaction` - transaction object returned by `doGetTransaction`
        `definition` - TransactionDefinition instance, describing propagation behavior, isolation level, read-only flag, timeout, and transaction name

    - #### doSuspend

          protected Object doSuspend(Object transaction)

      Description copied from class: `AbstractPlatformTransactionManager`
      Suspend the resources of the current transaction. Transaction synchronization will already have been suspended.

      The default implementation throws a TransactionSuspensionNotSupportedException, assuming that transaction suspension is generally not supported.

      Overrides:
        `doSuspend` in class `AbstractPlatformTransactionManager`
      Parameters:
        `transaction` - transaction object returned by `doGetTransaction`
      Returns:
        an object that holds suspended resources (will be kept unexamined for passing it into doResume)
      See Also:
        `AbstractPlatformTransactionManager.doResume(java.lang.Object, java.lang.Object)`

    - #### doResume

          protected void doResume(Object transaction,
                      Object suspendedResources)

      Description copied from class: `AbstractPlatformTransactionManager`
      Resume the resources of the current transaction. Transaction synchronization will be resumed afterwards.

      The default implementation throws a TransactionSuspensionNotSupportedException, assuming that transaction suspension is generally not supported.

      Overrides:
        `doResume` in class `AbstractPlatformTransactionManager`
      Parameters:
        `transaction` - transaction object returned by `doGetTransaction`
        `suspendedResources` - the object that holds suspended resources, as returned by doSuspend
      See Also:
        `AbstractPlatformTransactionManager.doSuspend(java.lang.Object)`

    - #### prepareForCommit

          protected void prepareForCommit(DefaultTransactionStatus status)

      Description copied from class: `AbstractPlatformTransactionManager`
      Make preparations for commit, to be performed before the `beforeCommit` synchronization callbacks occur.

      Note that exceptions will get propagated to the commit caller and cause a rollback of the transaction.

      Overrides:
        `prepareForCommit` in class `AbstractPlatformTransactionManager`
      Parameters:
        `status` - the status representation of the transaction

    - #### doCommit

          protected void doCommit(DefaultTransactionStatus status)

      Description copied from class: `AbstractPlatformTransactionManager`
      Perform an actual commit of the given transaction.

      An implementation does not need to check the "new transaction" flag or the rollback-only flag; this will already have been handled before. Usually, a straight commit will be performed on the transaction object contained in the passed-in status.

      Specified by:
        `doCommit` in class `AbstractPlatformTransactionManager`
      Parameters:
        `status` - the status representation of the transaction
      See Also:
        `DefaultTransactionStatus.getTransaction()`

    - #### doRollback

          protected void doRollback(DefaultTransactionStatus status)

      Description copied from class: `AbstractPlatformTransactionManager`
      Perform an actual rollback of the given transaction.

      An implementation does not need to check the "new transaction" flag; this will already have been handled before. Usually, a straight rollback will be performed on the transaction object contained in the passed-in status.

      Specified by:
        `doRollback` in class `AbstractPlatformTransactionManager`
      Parameters:
        `status` - the status representation of the transaction
      See Also:
        `DefaultTransactionStatus.getTransaction()`

    - #### doSetRollbackOnly

          protected void doSetRollbackOnly(DefaultTransactionStatus status)

      Description copied from class: `AbstractPlatformTransactionManager`
      Set the given transaction rollback-only. Only called on rollback if the current transaction participates in an existing one.

      The default implementation throws an IllegalTransactionStateException, assuming that participating in existing transactions is generally not supported. Subclasses are of course encouraged to provide such support.

      Overrides:
        `doSetRollbackOnly` in class `AbstractPlatformTransactionManager`
      Parameters:
        `status` - the status representation of the transaction

    - #### doCleanupAfterCompletion

          protected void doCleanupAfterCompletion(Object transaction)

      Description copied from class: `AbstractPlatformTransactionManager`
      Cleanup resources after transaction completion.

      Called after `doCommit` and `doRollback` execution, on any outcome. The default implementation does nothing.

      Should not throw any exceptions but just issue warnings on errors.

      Overrides:
        `doCleanupAfterCompletion` in class `AbstractPlatformTransactionManager`
      Parameters:
        `transaction` - transaction object returned by `doGetTransaction`

    - #### isSameConnectionForEntireSession

          protected boolean isSameConnectionForEntireSession(Session session)

      Return whether the given Hibernate Session will always hold the same JDBC Connection. This is used to check whether the transaction manager can safely prepare and clean up the JDBC Connection used for a transaction.

      Default implementation checks the Session's connection release mode to be "on_close". Unfortunately, this requires casting to SessionImpl, as of Hibernate 3.1. If that cast doesn't work, we'll simply assume we're safe and return `true`.

      Parameters:
        `session` - the Hibernate Session to check
      See Also:
        `SessionImpl.getConnectionReleaseMode()`, `ConnectionReleaseMode.ON_CLOSE`

    - #### convertHibernateAccessException

          protected DataAccessException convertHibernateAccessException(HibernateException ex)

      Convert the given HibernateException to an appropriate exception from the `org.springframework.dao` hierarchy.

      Will automatically apply a specified SQLExceptionTranslator to a Hibernate JDBCException, else rely on Hibernate's default translation.

      Parameters:
        `ex` - HibernateException that occured
      Returns:
        a corresponding DataAccessException
      See Also:
        `SessionFactoryUtils.convertHibernateAccessException(org.hibernate.HibernateException)`, `setJdbcExceptionTranslator(org.springframework.jdbc.support.SQLExceptionTranslator)`

    - #### convertJdbcAccessException

          protected DataAccessException convertJdbcAccessException(JDBCException ex,
                                                       SQLExceptionTranslator translator)

      Convert the given Hibernate JDBCException to an appropriate exception from the `org.springframework.dao` hierarchy, using the given SQLExceptionTranslator.
      Parameters:
        `ex` - Hibernate JDBCException that occured
        `translator` - the SQLExceptionTranslator to use
      Returns:
        a corresponding DataAccessException

    - #### getDefaultJdbcExceptionTranslator

          protected SQLExceptionTranslator getDefaultJdbcExceptionTranslator()

      Obtain a default SQLExceptionTranslator, lazily creating it if necessary.

      Creates a default `SQLErrorCodeSQLExceptionTranslator` for the SessionFactory's underlying DataSource.